unit Input;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls;

const
  ArraySize = 30;

type
  TInputDialog = class(TForm)
    NumberStatesGroup: TGroupBox;
    NumberStatesEdit: TEdit;
    NumberStatesUpDown: TUpDown;
    SurvivalsGroup: TGroupBox;
    SurvivalsDisplay: TListBox;
    SurvivalsAddEdit: TEdit;
    SurvivalsAddButton: TButton;
    SurvivalsDeleteButton: TButton;
    SurvivalsClearButton: TButton;
    BirthsGroup: TGroupBox;
    BirthsDisplay: TListBox;
    BirthsAddEdit: TEdit;
    BirthsAddButton: TButton;
    BirthsDeleteButton: TButton;
    BirthsClearButton: TButton;
    StateWeightsGroup: TGroupBox;
    LabelS0: TLabel;
    EditS0: TEdit;
    UpDownS0: TUpDown;
    LabelS1: TLabel;
    EditS1: TEdit;
    UpDownS1: TUpDown;
    LabelS2: TLabel;
    EditS2: TEdit;
    UpDownS2: TUpDown;
    LabelS3: TLabel;
    EditS3: TEdit;
    UpDownS3: TUpDown;
    LabelS4: TLabel;
    EditS4: TEdit;
    UpDownS4: TUpDown;
    LabelS5: TLabel;
    EditS5: TEdit;
    UpDownS5: TUpDown;
    LabelS6: TLabel;
    EditS6: TEdit;
    UpDownS6: TUpDown;
    LabelS7: TLabel;
    EditS7: TEdit;
    UpDownS7: TUpDown;
    LabelS8: TLabel;
    EditS8: TEdit;
    UpDownS8: TUpDown;
    LabelS9: TLabel;
    EditS9: TEdit;
    UpDownS9: TUpDown;
    LabelS10: TLabel;
    EditS10: TEdit;
    UpDownS10: TUpDown;
    LabelS11: TLabel;
    EditS11: TEdit;
    UpDownS11: TUpDown;
    LabelS12: TLabel;
    EditS12: TEdit;
    UpDownS12: TUpDown;
    LabelS13: TLabel;
    EditS13: TEdit;
    UpDownS13: TUpDown;
    LabelS14: TLabel;
    EditS14: TEdit;
    UpDownS14: TUpDown;
    LabelS15: TLabel;
    EditS15: TEdit;
    UpDownS15: TUpDown;
    PositionWeightsGroup: TGroupBox;
    LabelPNW: TLabel;
    EditPNW: TEdit;
    UpDownPNW: TUpDown;
    LabelPN: TLabel;
    EditPN: TEdit;
    UpDownPN: TUpDown;
    LabelPNE: TLabel;
    EditPNE: TEdit;
    UpDownPNE: TUpDown;
    LabelPW: TLabel;
    EditPW: TEdit;
    UpDownPW: TUpDown;
    LabelPE: TLabel;
    EditPE: TEdit;
    UpDownPE: TUpDown;
    LabelSW: TLabel;
    EditPSW: TEdit;
    UpDownPSW: TUpDown;
    LabelPS: TLabel;
    EditPS: TEdit;
    UpDownPS: TUpDown;
    LabelPSE: TLabel;
    EditPSE: TEdit;
    UpDownPSE: TUpDown;
    RuleText: TEdit;
    OkButton: TButton;
    CancelButton: TButton;
    LabelByLine: TLabel;
    procedure FormActivate(Sender: TObject);
    procedure BirthsAddButtonClick(Sender: TObject);
    procedure BirthsDeleteButtonClick(Sender: TObject);
    procedure BirthsClearButtonClick(Sender: TObject);
    procedure SurvivalsAddButtonClick(Sender: TObject);
    procedure SurvivalsDeleteButtonClick(Sender: TObject);
    procedure SurvivalsClearButtonClick(Sender: TObject);
    procedure OkButtonClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure DisplayRuleText(Sender: TObject);
  private
    procedure Apply();
  public
  end;

  procedure InitRuleFromString(sStr: String);
  function GetRuleAsString: String;

type
  StateWeightsType = Array[0..15] of Integer;
  PositionWeightsType = Array[0..7] of Integer;
  ListType = Array[1..ArraySize] of Integer;

var
  NumberOfStates: Integer;
  StateWeights: StateWeightsType;
  PositionWeights: PositionWeightsType;
  BirthCount: Integer;
  BirthList: ListType;
  SurvivalCount: Integer;
  SurvivalList: ListType;

implementation

uses
  uMWStrings;

{$R *.DFM}

procedure TInputDialog.FormActivate(Sender: TObject);
var
  I: Integer;

  procedure SetEdit(Edit: TEdit; Value: Integer);
  begin
    Edit.ReadOnly := False;
    Edit.Text := IntToStr(Value);
    Edit.ReadOnly := True
  end;

begin
  SetEdit(NumberStatesEdit, NumberOfStates);
  SetEdit(EditS0,  StateWeights[ 0]);
  SetEdit(EditS1,  StateWeights[ 1]);
  SetEdit(EditS2,  StateWeights[ 2]);
  SetEdit(EditS3,  StateWeights[ 3]);
  SetEdit(EditS4,  StateWeights[ 4]);
  SetEdit(EditS5,  StateWeights[ 5]);
  SetEdit(EditS6,  StateWeights[ 6]);
  SetEdit(EditS7,  StateWeights[ 7]);
  SetEdit(EditS8,  StateWeights[ 8]);
  SetEdit(EditS9,  StateWeights[ 9]);
  SetEdit(EditS10, StateWeights[10]);
  SetEdit(EditS11, StateWeights[11]);
  SetEdit(EditS12, StateWeights[12]);
  SetEdit(EditS13, StateWeights[13]);
  SetEdit(EditS14, StateWeights[14]);
  SetEdit(EditS15, StateWeights[15]);
  SetEdit(EditPNW, PositionWeights[0]);
  SetEdit(EditPN,  PositionWeights[1]);
  SetEdit(EditPNE, PositionWeights[2]);
  SetEdit(EditPW,  PositionWeights[3]);
  SetEdit(EditPE,  PositionWeights[4]);
  SetEdit(EditPSW, PositionWeights[5]);
  SetEdit(EditPS,  PositionWeights[6]);
  SetEdit(EditPSE, PositionWeights[7]);
  for I := 1 to BirthCount do
    BirthsDisplay.Items.Strings[I - 1] := IntToStr(BirthList[I]);
  for I := 1 to SurvivalCount do
    SurvivalsDisplay.Items.Strings[I - 1] := IntToStr(SurvivalList[I]);
  DisplayRuleText(Nil)
end;

procedure TInputDialog.BirthsAddButtonClick(Sender: TObject);
var
  NewValue, Value, ErrorCode, I, N: Integer;
begin
  Val(BirthsAddEdit.Text, NewValue, ErrorCode);
  if (ErrorCode <> 0) or (NewValue < 0) then
    MessageDlg('Error: must be a positive integer', mtError, [mbOK], 0)
  else
  begin
    N := BirthsDisplay.Items.Count - 1;
    if (N < 0) or (StrToInt(BirthsDisplay.Items.Strings[N]) < NewValue) then
      BirthsDisplay.Items.Add(BirthsAddEdit.Text)
    else
      for I := 0 to N do
      begin
        Value := StrToInt(BirthsDisplay.Items.Strings[I]);
        if NewValue = Value then
          Break;
        if NewValue < Value then
        begin
          BirthsDisplay.Items.Insert(I, BirthsAddEdit.Text);
          Break
        end
      end
  end;
  BirthsAddEdit.Text := '';
  DisplayRuleText(Nil)
end;

procedure TInputDialog.BirthsDeleteButtonClick(Sender: TObject);
begin
  BirthsDisplay.Items.Delete(BirthsDisplay.ItemIndex);
  DisplayRuleText(Nil)
end;

procedure TInputDialog.BirthsClearButtonClick(Sender: TObject);
begin
  BirthsDisplay.Clear;
  BirthsAddEdit.Clear;
  DisplayRuleText(Nil)
end;

procedure TInputDialog.SurvivalsAddButtonClick(Sender: TObject);
var
  NewValue, Value, ErrorCode, I, N: Integer;
begin
  Val(SurvivalsAddEdit.Text, NewValue, ErrorCode);
  if (ErrorCode <> 0) or (NewValue < 0) then
    MessageDlg('Error: must be a positive integer', mtError, [mbOK], 0)
  else
  begin
    N := SurvivalsDisplay.Items.Count - 1;
    if (N < 0) or (StrToInt(SurvivalsDisplay.Items.Strings[N]) < NewValue) then
      SurvivalsDisplay.Items.Add(SurvivalsAddEdit.Text)
    else
      for I := 0 to N do
      begin
        Value := StrToInt(SurvivalsDisplay.Items.Strings[I]);
        if NewValue = Value then
          Break;
        if NewValue < Value then
        begin
          SurvivalsDisplay.Items.Insert(I, SurvivalsAddEdit.Text);
          Break
        end
      end
  end;
  SurvivalsAddEdit.Text := '';
  DisplayRuleText(Nil)
end;

procedure TInputDialog.SurvivalsDeleteButtonClick(Sender: TObject);
begin
  SurvivalsDisplay.Items.Delete(SurvivalsDisplay.ItemIndex);
  DisplayRuleText(Nil)
end;

procedure TInputDialog.SurvivalsClearButtonClick(Sender: TObject);
begin
  SurvivalsDisplay.Clear;
  SurvivalsAddEdit.Clear;
  DisplayRuleText(Nil)
end;

procedure TInputDialog.Apply();
var
    I: Integer;
begin
  NumberOfStates := StrToInt(NumberStatesEdit.Text);
  StateWeights[ 0] := StrToInt(EditS0.Text);
  StateWeights[ 1] := StrToInt(EditS1.Text);
  StateWeights[ 2] := StrToInt(EditS2.Text);
  StateWeights[ 3] := StrToInt(EditS3.Text);
  StateWeights[ 4] := StrToInt(EditS4.Text);
  StateWeights[ 5] := StrToInt(EditS5.Text);
  StateWeights[ 6] := StrToInt(EditS6.Text);
  StateWeights[ 7] := StrToInt(EditS7.Text);
  StateWeights[ 8] := StrToInt(EditS8.Text);
  StateWeights[ 9] := StrToInt(EditS9.Text);
  StateWeights[10] := StrToInt(EditS10.Text);
  StateWeights[11] := StrToInt(EditS11.Text);
  StateWeights[12] := StrToInt(EditS12.Text);
  StateWeights[13] := StrToInt(EditS13.Text);
  StateWeights[14] := StrToInt(EditS14.Text);
  StateWeights[15] := StrToInt(EditS15.Text);
  PositionWeights[0] := StrToInt(EditPNW.Text);
  PositionWeights[1] := StrToInt(EditPN.Text);
  PositionWeights[2] := StrToInt(EditPNE.Text);
  PositionWeights[3] := StrToInt(EditPW.Text);
  PositionWeights[4] := StrToInt(EditPE.Text);
  PositionWeights[5] := StrToInt(EditPSW.Text);
  PositionWeights[6] := StrToInt(EditPS.Text);
  PositionWeights[7] := StrToInt(EditPSE.Text);
  SurvivalCount := SurvivalsDisplay.Items.Count;
  for I := 1 to SurvivalCount do
    SurvivalList[I] := StrToInt(SurvivalsDisplay.Items.Strings[I - 1]);
  BirthCount := BirthsDisplay.Items.Count;
  for I := 1 to BirthCount do
    BirthList[I] := StrToInt(BirthsDisplay.Items.Strings[I - 1])
end;

procedure TInputDialog.OkButtonClick(Sender: TObject);
begin
  Apply;
  Close
end;

procedure TInputDialog.CancelButtonClick(Sender: TObject);
begin
  Close
end;

procedure TInputDialog.DisplayRuleText(Sender: TObject);
var
  SaveNumberOfStates: Integer;
  SaveStateWeights: StateWeightsType;
  SavePositionWeights: PositionWeightsType;
  SaveBirthCount: Integer;
  SaveBirthList: ListType;
  SaveSurvivalCount: Integer;
  SaveSurvivalList: ListType;
begin
  SaveNumberOfStates := NumberOfStates;
  SaveStateWeights := StateWeights;
  SavePositionWeights := PositionWeights;
  SaveBirthCount := BirthCount;
  SaveBirthList := BirthList;
  SaveSurvivalCount := SurvivalCount;
  SaveSurvivalList := SurvivalList;
  Apply();
  RuleText.Text := GetRuleAsString();
  NumberOfStates := SaveNumberOfStates;
  StateWeights := SaveStateWeights;
  PositionWeights := SavePositionWeights;
  BirthCount := SaveBirthCount;
  BirthList := SaveBirthList;
  SurvivalCount := SaveSurvivalCount;
  SurvivalList := SaveSurvivalList
end;

function BoundInt(iMin: Integer; var iVal: Integer; iMax: Integer): Integer;
var
  iTmp: Integer;
begin
  if iMin > iMax then
  begin
    iTmp := iMin;
    iMin := iMax;
    iMax := iTmp;
  end;
  if iVal < iMin then iVal := iMin;
  if iVal > iMax then iVal := iMax;
  BoundInt := iVal;
end;

procedure InitRuleFromString(sStr: String);
// Example:
//   C5,SW0;1;0;0;2,PW5;2;5;2;2;5;2;5,RS10;12,RB1;2;5;13
var
  sTok, sSubtok: String;
  i, iTmp, iNum: Integer;
begin
  NumberOfStates := 2;
  for i := 0 to 15 do
    StateWeights[i] := 0;
  StateWeights[1] := 1;
  for i := 0 to 7 do
    PositionWeights[i] := 1;
  SurvivalCount := 0;
  for i := 1 to ArraySize do
    SurvivalList[i] := 0;
  BirthCount := 0;
  for i := 1 to ArraySize do
    BirthList[i] := 0;
  if Length(sStr) > 0 then
  begin
    // count of states
    i := 1; sTok := GetTokenStartingWith(sStr, 'C', ',', i);
    if Length(sTok) > 1 then
      NumberOfStates := CvtStr2Int(Copy(sTok, 2, 10));
    if (NumberOfStates < 1) or (NumberOfStates > 16) then
      NumberOfStates := 2;

    // state weights
    i := 1; sTok := GetTokenStartingWith(sStr, 'SW', ',', i);
    if Length(sTok) > 2 then
      sSubtok := Copy(sTok, 3, Length(sTok) - 1);
    i := 1; sTok := GetNextToken(sSubtok, i, ';');
    iNum := 0;
    while (Length(sTok) > 0) and (iNum <= 15) do
    begin
      iTmp := CvtStr2Int(sTok);
      BoundInt(0, iTmp, 10);
      StateWeights[iNum] := iTmp;
      Inc(iNum);
      sTok := GetNextToken(sSubtok, i, ';')
    end;

    // position weights
    i := 1; sTok := GetTokenStartingWith(sStr, 'PW', ',', i);
    if Length(sTok) > 2 then
      sSubtok := Copy(sTok, 3, Length(sTok) - 1);
    i := 1; sTok := GetNextToken(sSubtok, i, ';');
    iNum := 0;
    while (Length(sTok) > 0) and (iNum <= 7) do
    begin
      iTmp := CvtStr2Int(sTok);
      BoundInt(0, iTmp, 10);
      PositionWeights[iNum] := iTmp;
      Inc(iNum);
      sTok := GetNextToken(sSubtok, i, ';')
    end;

    // survival list
    i := 1; sTok := GetTokenStartingWith(sStr, 'RS', ',', i);
    sSubtok := '';
    if Length(sTok) > 2 then
      sSubtok := Copy(sTok, 3, Length(sTok) - 1);
    i := 1; sTok := GetNextToken(sSubtok, i, ';');
    SurvivalCount := 0;
    while (Length(sTok) > 0) and (iNum <= ArraySize) do
    begin
      iTmp := CvtStr2Int(sTok);
      BoundInt(0, iTmp, 32000);
      Inc(SurvivalCount);
      SurvivalList[SurvivalCount] := iTmp;
      sTok := GetNextToken(sSubtok, i, ';')
    end;

    // birth list
    i := 1; sTok := GetTokenStartingWith(sStr, 'RB', ',', i);
    sSubtok := '';
    if Length(sTok) > 2 then
      sSubtok := Copy(sTok, 3, Length(sTok) - 1);
    i := 1; sTok := GetNextToken(sSubtok, i, ';');
    BirthCount := 0;
    while (Length(sTok) > 0) and (iNum <= ArraySize) do
    begin
      iTmp := CvtStr2Int(sTok);
      BoundInt(0, iTmp, 32000);
      Inc(BirthCount);
      BirthList[BirthCount] := iTmp;
      sTok := GetNextToken(sSubtok, i, ';')
    end
  end
end;

function GetRuleAsString: String;
// Example:
//   C5,SW0;1;0;0;2,PW5;2;5;2;2;5;2;5,RS10;12,RB1;2;5;13
var
  i: Integer;
  sBff: String;
begin
  sBff := 'C' + IntToStr(NumberOfStates);
  sBff := sBff + ',' + 'SW';
  for i := 0 to NumberOfStates - 2 do
    sBff := sBff + IntToStr(StateWeights[i]) + ';';
  sBff := sBff + IntToStr(StateWeights[NumberOfStates - 1]);
  sBff := sBff + ',' + 'PW';
  for i := 0 to 6 do
    sBff := sBff + IntToStr(PositionWeights[i]) + ';';
  sBff := sBff + IntToStr(PositionWeights[7]);
  sBff := sBff + ',' + 'RS';
  for i := 1 to SurvivalCount do
  begin
    sBff := sBff + IntToStr(SurvivalList[i]);
    if i < SurvivalCount then
      sBff := sBff + ';'
  end;
  sBff := sBff + ',' + 'RB';
  for i := 1 to BirthCount do
  begin
    sBff := sBff + IntToStr(BirthList[i]);
    if i < BirthCount then
      sBff := sBff + ';'
  end;   
  GetRuleAsString := sBff
end;

end.
